
/*******************************************************************************
*
* File check3.c
*
* Copyright (C) 2014 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
* Check of the program reorder_dgm().
*
*******************************************************************************/

#define MAIN_PROGRAM

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "utils.h"
#include "diagrams.h"


static diagram_t **dgm1(void)
{
   int i;
   int (*v)[2];
   line_t *l;
   diagram_t **dgm;

   dgm=malloc(4*sizeof(*dgm));
   error(dgm==NULL,1,"dgm1 [check3.c]","Unable to allocate diagram array");

   dgm[0]=alloc_dgm(5,4);
   v=dgm[0][0].v;
   l=dgm[0][0].l;

   for (i=0;i<4;i++)
   {
      v[i][0]=1;
      v[i][1]=0;
   }

   v[4][0]=1;
   v[4][1]=1;

   for (i=0;i<4;i++)
   {
      l[i].type=SCALAR;
      l[i].iv[0]=i;
   }

   l[0].iv[1]=4;
   l[1].iv[1]=4;
   l[2].iv[1]=1;
   l[3].iv[1]=1;

   dgm[1]=alloc_dgm(8,7);
   v=dgm[1][0].v;
   l=dgm[1][0].l;

   for (i=0;i<2;i++)
   {
      v[i][0]=0;
      v[i][1]=1;
   }

   for (i=2;i<8;i++)
   {
      v[i][0]=1;
      v[i][1]=0;
   }

   for (i=0;i<7;i++)
   {
      l[i].type=SCALAR;
      l[i].iv[0]=i;
   }

   l[0].iv[1]=5;
   l[1].iv[1]=2;
   l[2].iv[1]=3;
   l[3].iv[1]=4;
   l[4].iv[1]=5;
   l[5].iv[1]=2;
   l[6].iv[1]=7;

   dgm[2]=alloc_dgm(4,6);
   v=dgm[2][0].v;
   l=dgm[2][0].l;

   for (i=0;i<4;i++)
   {
      v[i][0]=1;
      v[i][1]=0;
   }

   for (i=0;i<6;i++)
      l[i].type=SCALAR;

   l[0].iv[0]=0;
   l[0].iv[1]=2;

   l[1].iv[0]=0;
   l[1].iv[1]=3;

   l[2].iv[0]=1;
   l[2].iv[1]=2;

   l[3].iv[0]=1;
   l[3].iv[1]=3;

   l[4].iv[0]=2;
   l[4].iv[1]=3;

   l[5].iv[0]=3;
   l[5].iv[1]=2;

   dgm[3]=alloc_dgm(2,4);
   v=dgm[3][0].v;
   l=dgm[3][0].l;

   for (i=0;i<2;i++)
   {
      v[i][0]=1;
      v[i][1]=0;
   }

   for (i=0;i<4;i++)
      l[i].type=SCALAR;

   l[0].iv[0]=0;
   l[0].iv[1]=1;

   l[1].iv[0]=0;
   l[1].iv[1]=1;

   l[2].iv[0]=1;
   l[2].iv[1]=0;

   l[3].iv[0]=0;
   l[3].iv[1]=1;

   return dgm;
}


static diagram_t **dgm2(void)
{
   int i;
   int (*v)[2];
   line_t *l;
   diagram_t **dgm;

   dgm=malloc(4*sizeof(*dgm));
   error(dgm==NULL,1,"dgm2 [check3.c]","Unable to allocate diagram array");

   dgm[0]=alloc_dgm(4,5);
   v=dgm[0][0].v;
   l=dgm[0][0].l;

   for (i=0;i<2;i++)
   {
      v[i][0]=1;
      v[i][1]=0;
   }

   for (i=2;i<4;i++)
   {
      v[i][0]=1;
      v[i][1]=1;
   }

   for (i=0;i<3;i++)
      l[i].type=GLUON;

   l[3].type=GHOST;
   l[4].type=ANTIGHOST;

   l[0].iv[0]=0;
   l[0].iv[1]=1;

   l[1].iv[0]=0;
   l[1].iv[1]=2;

   l[2].iv[0]=1;
   l[2].iv[1]=3;

   l[3].iv[0]=2;
   l[3].iv[1]=3;

   l[4].iv[0]=2;
   l[4].iv[1]=3;

   dgm[1]=alloc_dgm(6,8);
   v=dgm[1][0].v;
   l=dgm[1][0].l;

   for (i=0;i<6;i++)
   {
      v[i][0]=1;
      v[i][1]=0;
   }

   for (i=0;i<8;i++)
      l[i].type=GLUON;

   l[0].iv[0]=0;
   l[0].iv[1]=2;

   l[1].iv[0]=0;
   l[1].iv[1]=4;

   l[2].iv[0]=1;
   l[2].iv[1]=3;

   l[3].iv[0]=1;
   l[3].iv[1]=5;

   l[4].iv[0]=4;
   l[4].iv[1]=5;

   l[5].iv[0]=5;
   l[5].iv[1]=3;

   l[6].iv[0]=3;
   l[6].iv[1]=2;

   l[7].iv[0]=2;
   l[7].iv[1]=4;

   dgm[2]=alloc_dgm(6,8);
   v=dgm[2][0].v;
   l=dgm[2][0].l;

   for (i=0;i<2;i++)
   {
      v[i][0]=1;
      v[i][1]=0;
   }

   for (i=2;i<6;i++)
   {
      v[i][0]=1;
      v[i][1]=1;
   }

   for (i=0;i<4;i++)
      l[i].type=GLUON;

   for (i=4;i<8;i++)
      l[i].type=GHOST;

   l[0].iv[0]=0;
   l[0].iv[1]=2;

   l[1].iv[0]=0;
   l[1].iv[1]=4;

   l[2].iv[0]=1;
   l[2].iv[1]=3;

   l[3].iv[0]=1;
   l[3].iv[1]=5;

   l[4].iv[0]=4;
   l[4].iv[1]=5;

   l[5].iv[0]=5;
   l[5].iv[1]=3;

   l[6].iv[0]=3;
   l[6].iv[1]=2;

   l[7].iv[0]=2;
   l[7].iv[1]=4;

   dgm[3]=alloc_dgm(6,9);
   v=dgm[3][0].v;
   l=dgm[3][0].l;

   for (i=0;i<2;i++)
   {
      v[i][0]=2;
      v[i][1]=0;
   }

   for (i=2;i<4;i++)
   {
      v[i][0]=1;
      v[i][1]=0;
   }

   for (i=4;i<6;i++)
   {
      v[i][0]=1;
      v[i][1]=1;
   }

   for (i=0;i<7;i++)
      l[i].type=GLUON;

   for (i=7;i<9;i++)
      l[i].type=ANTIGHOST;

   l[0].iv[0]=0;
   l[0].iv[1]=1;

   l[1].iv[0]=0;
   l[1].iv[1]=1;

   l[2].iv[0]=1;
   l[2].iv[1]=1;

   l[3].iv[0]=0;
   l[3].iv[1]=2;

   l[4].iv[0]=2;
   l[4].iv[1]=3;

   l[5].iv[0]=3;
   l[5].iv[1]=2;

   l[6].iv[0]=3;
   l[6].iv[1]=4;

   l[7].iv[0]=4;
   l[7].iv[1]=5;

   l[8].iv[0]=5;
   l[8].iv[1]=4;

   return dgm;
}


static diagram_t **dgm3(void)
{
   int i;
   int (*v)[2];
   line_t *l;
   diagram_t **dgm;

   dgm=malloc(4*sizeof(*dgm));
   error(dgm==NULL,1,"dgm3 [check3.c]","Unable to allocate diagram array");

   dgm[0]=alloc_dgm(6,8);
   v=dgm[0][0].v;
   l=dgm[0][0].l;

   for (i=0;i<2;i++)
   {
      v[i][0]=2;
      v[i][1]=0;
   }

   for (i=2;i<6;i++)
   {
      v[i][0]=1;
      v[i][1]=2;
   }

   for (i=0;i<5;i++)
      l[i].type=GLUON;

   for (i=5;i<8;i++)
      l[i].type=QUARK;

   l[0].iv[0]=0;
   l[0].iv[1]=1;

   l[1].iv[0]=1;
   l[1].iv[1]=0;

   l[2].iv[0]=0;
   l[2].iv[1]=2;

   l[3].iv[0]=3;
   l[3].iv[1]=1;

   l[4].iv[0]=4;
   l[4].iv[1]=1;

   l[5].iv[0]=2;
   l[5].iv[1]=3;

   l[6].iv[0]=3;
   l[6].iv[1]=2;

   l[7].iv[0]=4;
   l[7].iv[1]=5;

   dgm[1]=alloc_dgm(7,10);
   v=dgm[1][0].v;
   l=dgm[1][0].l;

   for (i=0;i<2;i++)
   {
      v[i][0]=1;
      v[i][1]=0;
   }

   v[2][0]=2;
   v[2][1]=0;

   for (i=3;i<7;i++)
   {
      v[i][0]=1;
      v[i][1]=2;
   }

   for (i=0;i<6;i++)
      l[i].type=GLUON;

   for (i=6;i<8;i++)
      l[i].type=QUARK;

   for (i=8;i<10;i++)
      l[i].type=ANTIQUARK;

   l[0].iv[0]=0;
   l[0].iv[1]=3;

   l[1].iv[0]=0;
   l[1].iv[1]=5;

   l[2].iv[0]=1;
   l[2].iv[1]=6;

   l[3].iv[0]=1;
   l[3].iv[1]=4;

   l[4].iv[0]=1;
   l[4].iv[1]=2;

   l[5].iv[0]=2;
   l[5].iv[1]=2;

   l[6].iv[0]=5;
   l[6].iv[1]=6;

   l[7].iv[0]=4;
   l[7].iv[1]=3;

   l[8].iv[0]=5;
   l[8].iv[1]=6;

   l[9].iv[0]=4;
   l[9].iv[1]=3;

   dgm[2]=alloc_dgm(5,8);
   v=dgm[2][0].v;
   l=dgm[2][0].l;

   v[0][0]=2;
   v[0][1]=0;

   for (i=1;i<5;i++)
   {
      v[i][0]=1;
      v[i][1]=2;
   }

   for (i=0;i<4;i++)
      l[i].type=GLUON;

   for (i=4;i<8;i++)
      l[i].type=QUARK;

   l[0].iv[0]=0;
   l[0].iv[1]=1;

   l[1].iv[0]=0;
   l[1].iv[1]=2;

   l[2].iv[0]=0;
   l[2].iv[1]=3;

   l[3].iv[0]=0;
   l[3].iv[1]=4;

   l[4].iv[0]=1;
   l[4].iv[1]=2;

   l[5].iv[0]=2;
   l[5].iv[1]=3;

   l[6].iv[0]=3;
   l[6].iv[1]=4;

   l[7].iv[0]=4;
   l[7].iv[1]=1;

   dgm[3]=alloc_dgm(9,12);
   v=dgm[3][0].v;
   l=dgm[3][0].l;

   for (i=0;i<2;i++)
   {
      v[i][0]=1;
      v[i][1]=2;
   }

   for (i=2;i<6;i++)
   {
      v[i][0]=1;
      v[i][1]=1;
   }

   for (i=6;i<9;i++)
   {
      v[i][0]=1;
      v[i][1]=0;
   }

   for (i=0;i<6;i++)
      l[i].type=GLUON;

   for (i=6;i<8;i++)
      l[i].type=QUARK;

   for (i=8;i<12;i++)
      l[i].type=GHOST;

   l[0].iv[0]=1;
   l[0].iv[1]=6;

   l[1].iv[0]=5;
   l[1].iv[1]=8;

   l[2].iv[0]=3;
   l[2].iv[1]=7;

   l[3].iv[0]=6;
   l[3].iv[1]=7;

   l[4].iv[0]=6;
   l[4].iv[1]=8;

   l[5].iv[0]=7;
   l[5].iv[1]=8;

   l[6].iv[0]=0;
   l[6].iv[1]=1;

   l[7].iv[0]=1;
   l[7].iv[1]=0;

   l[8].iv[0]=5;
   l[8].iv[1]=4;

   l[9].iv[0]=4;
   l[9].iv[1]=5;

   l[10].iv[0]=2;
   l[10].iv[1]=3;

   l[11].iv[0]=3;
   l[11].iv[1]=2;

   return dgm;
}


static void print_dgm(diagram_t *dm,diagram_t *dms,int *rk)
{
   int nv,nl,i;
   int (*v)[2],(*vs)[2];
   line_t *l,*ls;

   nv=(*dm).nv;
   nl=(*dm).nl;
   v=(*dm).v;
   l=(*dm).l;
   vs=(*dms).v;
   ls=(*dms).l;

   error((nv!=(*dms).nv)||(nl!=(*dms).nl),1,"print_dgm [check3.c]",
         "Unexpected diagram data");

   for (i=0;i<nv;i++)
   {
      printf(" %2d  %d,%d",i,v[i][0],v[i][1]);
      printf(" | %2d  %d,%d",rk[i],vs[i][0],vs[i][1]);
      printf("\n");
   }

   printf("\n");

   for (i=0;i<nl;i++)
   {
      printf("%2d=>%2d ",l[i].iv[0],l[i].iv[1]);

      if (l[i].type==SCALAR)
         printf("SCALAR   ");
      else if (l[i].type==GLUON)
         printf("GLUON    ");
      else if (l[i].type==GHOST)
         printf("GHOST    ");
      else if (l[i].type==ANTIGHOST)
         printf("ANTIGHOST");
      else if (l[i].type==QUARK)
         printf("QUARK    ");
      else if (l[i].type==ANTIQUARK)
         printf("ANTIQUARK");
      else
         error(1,1,"print_dgm [check3.c]","Unknown line type");

      printf(" | %2d=>%2d ",ls[i].iv[0],ls[i].iv[1]);

      if (ls[i].type==SCALAR)
         printf("SCALAR   ");
      else if (ls[i].type==GLUON)
         printf("GLUON    ");
      else if (ls[i].type==GHOST)
         printf("GHOST    ");
      else if (ls[i].type==ANTIGHOST)
         printf("ANTIGHOST");
      else if (ls[i].type==QUARK)
         printf("QUARK    ");
      else if (ls[i].type==ANTIQUARK)
         printf("ANTIQUARK");
      else
         error(1,1,"print_dgm [check3.c]","Unknown line type");

      printf("\n");
   }

   printf("\n");
}


int main(void)
{
   int i;
   int rk[9];
   diagram_t **dgm,*dms;
   theory_t th;

   printf("\n");
   printf("Check of the program reorder_dgm()\n");
   printf("----------------------------------\n\n");

   printf("PHI4\n");
   printf("----\n\n");

   th=PHI4;
   dgm=dgm1();

   for (i=0;i<4;i++)
   {
      dms=alloc_dgm(dgm[i][0].nv,dgm[i][0].nl);
      copy_dgm(dgm[i],dms);
      reorder_dgm(dms,rk);
      check_dgm(th,12,dms);
      print_dgm(dgm[i],dms,rk);
      free_dgm(dms);
   }

   for (i=0;i<4;i++)
      free_dgm(dgm[i]);

   free(dgm);

   printf("YM\n");
   printf("--\n\n");

   th=YM;
   dgm=dgm2();

   for (i=0;i<4;i++)
   {
      dms=alloc_dgm(dgm[i][0].nv,dgm[i][0].nl);
      copy_dgm(dgm[i],dms);
      reorder_dgm(dms,rk);
      check_dgm(th,12,dms);
      print_dgm(dgm[i],dms,rk);
      free_dgm(dms);
   }

   for (i=0;i<4;i++)
      free_dgm(dgm[i]);

   free(dgm);

   printf("QCD\n");
   printf("---\n\n");

   th=QCD;
   dgm=dgm3();

   for (i=0;i<4;i++)
   {
      dms=alloc_dgm(dgm[i][0].nv,dgm[i][0].nl);
      copy_dgm(dgm[i],dms);
      reorder_dgm(dms,rk);
      check_dgm(th,12,dms);
      print_dgm(dgm[i],dms,rk);
      free_dgm(dms);
   }

   for (i=0;i<4;i++)
      free_dgm(dgm[i]);

   free(dgm);

   exit(0);
}
