
/*******************************************************************************
*
* File check2.c
*
* Copyright (C) 2014 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
* Visual checks of the programs in the module cnum.c.
*
*******************************************************************************/

#define MAIN_PROGRAM

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "utils.h"


int main(void)
{
   int i;
   long (*r)[2];
   double f0,f1,f;
   cnum_t *cn;

   printf("\n");
   printf("Coefficient arithmetic\n");
   printf("----------------------\n\n");

   cn=alloc_cnum(12,0);
   r=malloc(4*sizeof(*r));
   error(r==NULL,1,"main [check2.c]","Unable to allocate auxiliary array");

   r[0][0]=3L;
   r[0][1]=15L;
   r[1][0]=-7L;
   r[1][1]=3L;
   r[2][0]=-5L;
   r[2][1]=-4L;

   set_cnum(1,r,cn);
   set_cnum(1,r+1,cn+1);

   printf("cn[0] = ");
   print_cnum(stdout,"N",cn);
   printf("\n");
   printf("cn[1] = ");
   print_cnum(stdout,"N",cn+1);
   printf("\n\n");

   copy_cnum(cn+1,cn+2);
   copy_cnum(cn,cn+3);
   copy_cnum(cn+1,cn+4);
   add_cnum(cn,cn+2);
   sub_cnum(cn+1,cn+3);
   mul_cnum(cn,cn+4);

   printf("cn[0]+cn[1] = ");
   print_cnum(stdout,"N",cn+2);
   printf("\n");
   printf("cn[0]-cn[1] = ");
   print_cnum(stdout,"N",cn+3);
   printf("\n");
   printf("cn[0]*cn[1] = ");
   print_cnum(stdout,"N",cn+4);
   printf("\n\n");

   printf("Setting N=1.234:\n");
   f0=eval_cnum(1.234,cn);
   f1=eval_cnum(1.234,cn+1);
   printf("cn[0] = % .15e\n",f0);
   printf("cn[1] = % .15e\n",f1);
   f=eval_cnum(1.234,cn+2);
   printf("d(cn[0]+cn[1]) = %.1e\n",fabs((f0+f1)/f-1.0));
   f=eval_cnum(1.234,cn+3);
   printf("d(cn[0]-cn[1]) = %.1e\n",fabs((f0-f1)/f-1.0));
   f=eval_cnum(1.234,cn+4);
   printf("d(cn[0]*cn[1]) = %.1e\n\n",fabs((f0*f1)/f-1.0));

   copy_cnum(cn,cn+5);
   f0=eval_cnum(1.234,cn+5);
   f1=1.0;

   for (i=0;i<9;i++)
   {
      f1*=f0;
      printf("cn[0]^%d = ",i+1);
      print_cnum(stdout,"N",cn+5);
      printf("\n");
      printf("Delta = %.1e\n",fabs(eval_cnum(1.234,cn+5)/f1-1.0));

      mul_cnum(cn,cn+5);
   }

   exit(0);
}
